#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <dlfcn.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <limits.h>

int
open (const char *path, int flags, mode_t mode)
{
	char buf[PATH_MAX], *home;
	int (*func) (const char *p, int f, mode_t m);

	if ((home = getenv ("HOME"))) {
		snprintf (buf, sizeof (buf), "%s/.Xdefaults", home);

		if (!strncmp (path, buf, strlen (buf))) {
			errno = EACCES;
			return -1;
		}
	}

	func = dlsym (RTLD_NEXT, "open");

	return func (path, flags, mode);
}
